#pragma once
#include "asmlib.h"
#include <math.h>


#define Tfloat double

const Tfloat FLOAT_256_Constant= 256.0;
const Tfloat FLOAT_256th_Constant= 1.0 / 256.0;
const Tfloat pi= 4.0 * atan ( 1.0 ) ;
const Tfloat halfpi= 2.0 * atan ( 1.0 ) ;

// there is a test/old sse version as well, inc number to use
//normal is 3
#define NumberOfCpuMethods 3


#define _Plane_FullSize 0
#define _Plane_HalfSize 2
#define _Plane_QuarterSize 4

typedef uint8 ArrayVals;

/*static bool HasSSE2() {
		if (::IsProcessorFeaturePresent( PF_XMMI64_INSTRUCTIONS_AVAILABLE ))
			return true;
		else
			return false;
		};*/


struct Struct_RGBA
{
	union
	{
		uint32 dw;
		uint8 b_g_r_a[4];
		struct
		{
			uint8 b;
			uint8 g;
			uint8 r;
			uint8 a;
		};
	};
};




struct Struct_DW_B
{
	union
	{
		uint32 dw;
		uint8 b[4];
		struct
		{
			uint8 b1;
			uint8 b2;
			uint8 b3;
			uint8 b4;
		};
	};
};

struct YUV_TableDefs
{
	ArrayVals Y_Table[256];
	ArrayVals U_Table[256][256];
	ArrayVals V_Table[256][256];
	bool AffectsY;
	bool AffectsUV;
};

struct T_RGBA
	{
		union
			{
				uint32 dw;
				uint8 bytes[4];
				struct
					{
						uint8 Blue;
						uint8 Green;
						uint8 Red;
						uint8 Alpha;
					};
			};
	};

typedef T_RGBA* P_RGBA ;

//extern
extern void  brightcont_run_transYUVPlanar (
        const VDXPixmap& srcimage,
        const VDXPixmap& dstimage,
        int HDiv,
        int WDiv,
        const YUV_TableDefs* YUV_Table,
        int MyCpuType,bool LeftHalfOnly
        );

extern void  brightcont_run_transYUYVInline(
									const VDXPixmap& srcimage,
									const VDXPixmap& dstimage,
									const YUV_TableDefs* YUV_Table,
									int MyCpuType,bool LeftHalfOnly
									 );

extern void  brightcont_run_transUYVYInline(
									const VDXPixmap& srcimage,
									const VDXPixmap& dstimage,
									const YUV_TableDefs* YUV_Table,
									int MyCpuType,bool LeftHalfOnly
									 );


////////////////////////////////////////////////////
// functions in a_brightlow.asm
//
extern "C" void asm_x86_YPlane(  void* SrcPlaneY,  uint32 SrcPitchY,
								 void* DstPlaneY,  uint32 DstPitchY,
							   uint32 DstHeight, uint32 DstWidth,
								 const void* Y_Table);

extern "C" void asm_x86_UVPlane( void* SrcPlaneU,  uint32 SrcPitchU,
								 void* SrcPlaneV,  uint32 SrcPitchV,
								 void* DstPlaneU,  uint32 DstPitchU,
								 void* DstPlaneV,  uint32 DstPitchV,
								 uint32 DstHeight, uint32 DstWidth,
								 const void* U_Table);
////////////
extern "C" void asm_sse_YPlane(  void*  SrcPlaneY,  uint32 SrcPitchY,
								 void*  DstPlaneY,  uint32 DstPitchY,
							     uint32 DstHeight,  uint32 DstWidth,
								 const void* Y_Table);

extern "C" void asm_sse_UVPlane( void* SrcPlaneU,  uint32 SrcPitchU,
								 void* SrcPlaneV,  uint32 SrcPitchV,
								 void* DstPlaneU,  uint32 DstPitchU,
								 void* DstPlaneV,  uint32 DstPitchV,
								 uint32 DstHeight, uint32 DstWidth,
								 const void* U_Table);
///////////////////////////////////////////////////////////////


extern "C" void asm_x86_UYVY( void* SrcPlane,  uint32 SrcPitch,
								  void* DstPlane,  uint32 DstPitch,
								  uint32 DstHeight, uint32 DstWidth,
								  const void* Y_Table);

extern "C" void asm_sse_UYVY( void* SrcPlane,  uint32 SrcPitch,
								  void* DstPlane,  uint32 DstPitch,
								  uint32 DstHeight, uint32 DstWidth,
								  const void* Y_Table);


extern "C" void asm_x86_YUYV( void* SrcPlane,  uint32 SrcPitch,
								  void* DstPlane,  uint32 DstPitch,
								  uint32 DstHeight, uint32 DstWidth,
								  const void* Y_Table);

extern "C" void asm_sse_YUYV( void* SrcPlane,  uint32 SrcPitch,
								  void* DstPlane,  uint32 DstPitch,
								  uint32 DstHeight, uint32 DstWidth,
								  const void* Y_Table);
/////////////////////////////////////////////////////////////////////////


