	%include "asm_macros.amc"

	segment	.text


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; asm_x86_UYVY
;
; in cpp use
;extern "C" void asm_x86_UYVY( void* SrcPlane,  uint32 SrcPitch,
;								  void* DstPlane,  uint32 DstPitch,
;								  uint32 DstHeight, uint32 DstWidth,
;								  const void* Y_Table);

%define oY1 0
%define oU 	1
%define oY2 2
%define oV 	3

procedure asm_x86_UYVY
	param SrcPlane		,4
	param SrcPitch		,4
	param DstPlane		,4
	param DstPitch		,4
	param DstHeight		,4
	param DstWidth		,4
	param Y_Table		,4
	
	var TempWidth		,4
	var TempSrcPlane	,4
	var TempDstPlane	,4

endvars
	
	mov edx,	[Y_Table]
	%define YTab edx
	%define UTab YTab+256
	%define VTab UTab+(256*256)
	
	mov	eax,	[DstWidth]	;2 bpp
	add [DstWidth],eax
	
		
align 32
LoopUVHeight:

				mov			eax, [DstWidth]
				mov			[TempWidth],eax


				mov         esi, [SrcPlane] 
				mov         [TempSrcPlane],esi 		 
				mov         edi, [DstPlane] 
				mov         [TempDstPlane],edi 						 
				;edx = lookup table addresses
				
				
align 64		;align on cache line
				;
				; layout	
				;	Y1UY2V		UY2VY1
				;	+0	Y1		U
				;	+1	U		Y2
				;	+2	Y2		V
				;	+3	V		Y1
LoopUVWidth:	
				mov ebx,[esi]				;Uy1Vy2
				
				;ecx = offset into u/v tables + (U*256+V)
				movzx ecx,bl				;U
				rol ebx,16
				shl ecx,8		
				mov cl,bl					;V
				ror ebx,8				
				mov al, byte [UTab+ecx]
				ror eax,16
				mov al, byte [VTab+ecx]
				ror eax,8
				
							
				movzx ecx,bl				;Y1
				ror ebx,16		
				mov al, byte [YTab+ecx]	;get lookup y1 val
				ror eax,16			
	
				movzx ecx,bl				;Y2	
				mov al, byte [YTab+ecx]		;get lookup y2 val	
				rol eax,8
				

				mov [edi],eax				;store new values


 
;.............End of width body
				add esi,dword 4
				add edi,dword 4
				
				sub [TempWidth],dword 4
				jg  LoopUVWidth
;.............End of width loop


;.............End of height body
				mov eax,[SrcPitch]
				add [SrcPlane],eax

				mov eax,[DstPitch]	
				add [DstPlane],eax

				sub [DstHeight],dword 1
				jg LoopUVHeight
;.............End of height loop



endprocedure
;
; end of asm_x86_YUV
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


