	%include "asm_macros.amc"

	segment	.text



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; asm_sse_UVPlane
;
; in cpp use
;extern "C" void asm_sse_UVPlane( void* SrcPlaneU,  uint32 SrcPitchU,
;								  void* SrcPlaneV,  uint32 SrcPitchV,
;								  void* DstPlaneU,  uint32 DstPitchU,
;								  void* DstPlaneV,  uint32 DstPitchV,
;								  uint32 DstHeight, uint32 DstWidth,
;								  const void* U_Table);

procedure asm_sse_UVPlane
	param SrcPlaneU		,4
	param SrcPitchU		,4
	param SrcPlaneV		,4
	param SrcPitchV		,4
	param DstPlaneU		,4
	param DstPitchU		,4
	param DstPlaneV		,4
	param DstPitchV		,4
	param DstHeight		,4
	param DstWidth		,4
	param U_Table		,4
	
	var TempWidth		,4
	var TempSrcPlane	,4
	var TempDstPlane	,4
	
	var TempDstPlaneU	,4
	var TempDstPlaneV	,4

	var TempSrcPlaneU	,4
	var TempSrcPlaneV	,4
	

endvars
		

		mov edi,[ U_Table] 
		
		%define UTable edi
		%define VTable edi+(256*256)
		
	;esi free

align 32
LoopUVHeight:
		mov eax, [SrcPlaneU] 
		mov [TempSrcPlaneU],eax 

		mov eax,[SrcPlaneV] 
		mov [TempSrcPlaneV],eax 				 

		mov eax,[DstPlaneU] 
		mov [TempDstPlaneU],eax 						 

		mov eax,[DstPlaneV] 
		mov [TempDstPlaneV],eax 


		mov  eax,[DstWidth]
		mov [TempWidth],eax
 
align 64
LoopUVWidth:			 
			;;;;;;;;;;;;;;;
			; U*256+V
			;
			;uses xmm0,xmm1,xmm2
			;output =xmm0
			
				pxor xmm2,xmm2	
				pxor xmm1,xmm1	
				
			mov ecx,[TempSrcPlaneU]
			add [TempSrcPlaneU],dword 16			;8
				MOVAPD xmm0, [ecx]				
				PSHUFD xmm6,xmm0, 1110b
			mov edx,[TempSrcPlaneV]			;interleaved	
				PUNPCKLBW xmm0,xmm1 
			add [TempSrcPlaneV],dword 16			;8			;interleaved	
				PSLLQ xmm0,8
				PUNPCKLBW xmm6,xmm1 
				MOVAPD xmm1, [edx]			;interleaved	
				PSLLQ xmm6,8
			
				PSHUFD xmm7,xmm1, 1110b
				PUNPCKLBW xmm1,xmm2 
				POR xmm0,xmm1
				PUNPCKLBW xmm7,xmm2 
				POR xmm6,xmm7

			;
			;result in xmm0,6 (8 bytes, converted to offsets into tables, by x*256+y
			;;;;;;;;;;;;;;;;;;;;;;;;;;


			;xmm6 scr2 ,next8 bytes of src1
			;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
			;

				%assign xmcounter 0
				%rep 2
					PEXTRW eax,xmm0,xmcounter
				%assign xmcounter xmcounter+1
					PEXTRW ebx,xmm0,xmcounter
					mov cl,[UTable+eax]		
					mov ch,[UTable+ebx]		
					ror ecx,16			
					mov dl,[VTable+eax]
					mov dh,[VTable+ebx]	
					ror edx,16
				%assign xmcounter xmcounter+1
				%endrep
				movd xmm4,ecx
				movd xmm5,edx
				%rep 2
					PEXTRW eax,xmm0,xmcounter
				%assign xmcounter xmcounter+1
					PEXTRW ebx,xmm0,xmcounter
					mov cl,[UTable+eax]	
					mov ch,[UTable+ebx]		
					ror ecx,16			
					mov dl,[VTable+eax]	
					mov dh,[VTable+ebx]	
					ror edx,16		
				%assign xmcounter xmcounter+1
				%endrep
				movd xmm3,ecx
				movd xmm7,edx
	
			PUNPCKLDQ xmm4,xmm3
			PUNPCKLDQ xmm5,xmm7
			; out xmm 4,5
			;;;;;;;;;;;;;;;;;;;
		
			;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
				%assign xmcounter 0
				%rep 2
					PEXTRW eax,xmm6,xmcounter						
				%assign xmcounter xmcounter+1
					PEXTRW ebx,xmm6,xmcounter						
					mov cl,byte [UTable+eax]	
					mov ch,byte [UTable+ebx]		
					ror ecx,16			
					mov dl,byte [VTable+eax]	
					mov dh,byte [VTable+ebx]	
					ror edx,16
				%assign xmcounter xmcounter+1
				%endrep
			movd xmm1,ecx
			movd xmm2,edx				

				%rep 2
					PEXTRW eax,xmm6,xmcounter						
				%assign xmcounter xmcounter+1	
					PEXTRW ebx,xmm6,xmcounter						
					mov cl,[UTable+eax]	
					mov ch,[UTable+ebx]		
					ror ecx,16			
					mov dl,[VTable+eax]
					mov dh,[VTable+ebx]	
					ror edx,16	
				%assign xmcounter xmcounter+1	
				%endrep
			movd xmm3,ecx
			movd xmm7,edx		
			
			PUNPCKLDQ xmm1,xmm3
			PUNPCKLDQ xmm2,xmm7

					;
					;out xmm 1,2
					;;;;;;;;;;;;;;;;;;;
					
					;;;;;;;;;;;;;;;;;;;;;;;
					; done, join 1 to 4, 5 to 2
					; then store into u and v planes
					;
					PUNPCKLQDQ xmm4,xmm1
					PUNPCKLQDQ xmm5,xmm2


					mov eax,[TempDstPlaneU]
					add [TempDstPlaneU],dword 16
						;cached
						movapd [eax],xmm4	
						;uncached
							;movntps [eax],xmm4		

					mov eax,[TempDstPlaneV]
					add [TempDstPlaneV],dword 16
						;cached
						movapd [eax],xmm5
						;uncached
							;MOVNTDQ [eax],xmm5			

					sub [TempWidth],dword 16
					will
					jg LoopUVWidth


				 
				mov eax,[SrcPitchU]	
				add [SrcPlaneU],eax
				mov eax,[SrcPitchV]	
				add [SrcPlaneV],eax
				mov eax,[DstPitchU]	
				add [DstPlaneU],eax
				mov eax,[DstPitchV]	
				add [DstPlaneV],eax
				sub [DstHeight],dword 1
				will		
				jg LoopUVHeight
				
				
				;uncached
					;sfence
				emms
endprocedure
;
; end of asm_x86_uvplane
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


