	%include "asm_macros.amc"

	segment	.text


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; asm_sse_YPlane
;
; in cpp use
;extern "C" void asm_sse_YPlane(  void*  SrcPlaneY,  uint32 SrcPitchY,
;								  void*  DstPlaneY,  uint32 DstPitchY,
;							      uint32 DstHeight,  uint32 DstWidth,
;								  const void* Y_Table);
;
procedure asm_sse_YPlane
	param SrcPlaneY		,4
	param SrcPitchY		,4
	param DstPlaneY		,4
	param DstPitchY		,4
	param DstHeight		,4
	param DstWidth		,4
	param Y_Table		,4
	
	var TempWidth		,4
	var TempSrcPlane	,4
	var TempDstPlane	,4
endvars
	


		
align 32
Loop_Yplane_Height:
					mov edx,[DstPlaneY]
					mov [TempDstPlane],edx

					mov edx,[DstWidth]
					mov [TempWidth],edx

					mov ebx,[SrcPlaneY]
					mov [TempSrcPlane],ebx

				 	mov	esi, [Y_Table]	;esi = y lookup table	;mov	ecx, [Y_Table]
					mov edi,[TempSrcPlane]			;edi = yplane current address
					mov ecx,[TempDstPlane]			;ecx = dest yplane

align 64
Loop_Yplane_Width:

;movapd xmm7,[edi]
;add edi,16
				%assign lcount 1
				%rep 4
					;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
					;	1		freed ecx
					;
				;	movd edx,xmm7
				;	PSHUFD xmm7,xmm7,  11111001b
					
						mov edx,[edi]
						add edi,4
						
						movzx eax,dl		
						movzx ebx, byte [esi+eax]	
						
						movzx eax,dh
						shr edx,16
						mov	bh, byte [esi+eax]
						shl ebx,16
						
						movzx eax,dl
						mov bl, byte [esi+eax]

						movzx eax,dh
						mov	bh, byte [esi+eax]
						ror ebx,16
				%if lcount=1
					movd xmm0,ebx	
					%endif	
				%if lcount=2
					movd xmm1,ebx	
					%endif	
				%if lcount=3
					movd xmm2,ebx	
					%endif	
				%if lcount=4
					movd xmm3,ebx	
					%endif						
				%assign lcount lcount+1
				%endrep


						PUNPCKLDQ  xmm0,xmm1
						PUNPCKLDQ  xmm2,xmm3
						PUNPCKLQDQ xmm0,xmm2

					;cached
						movapd [ecx],xmm0	
					;uncached
						;MOVNTDQ [ecx],xmm0	
						add ecx,16
			;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
			;	next width block
			;
					sub	[TempWidth],dword 16	
					will
					jg Loop_Yplane_Width


				mov edx,[SrcPitchY]
				add [SrcPlaneY],edx

				
				mov edx,[DstPitchY]
				add [DstPlaneY],edx

				sub [DstHeight],dword 1
				will
				jg Loop_Yplane_Height

emms
endprocedure
;
; end of asm_sse_yplane
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;



