	%include "asm_macros.amc"

	segment	.text



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; asm_x86_UVPlane
;
; in cpp use
;extern "C" void asm_x86_UVPlane( void* SrcPlaneU,  uint32 SrcPitchU,
;								  void* SrcPlaneV,  uint32 SrcPitchV,
;								  void* DstPlaneU,  uint32 DstPitchU,
;								  void* DstPlaneV,  uint32 DstPitchV,
;								  uint32 DstHeight, uint32 DstWidth,
;								  const void* U_Table);

%define b1 0
%define b2 1
%define b3 2
%define b4 3

procedure asm_x86_UVPlane
	param SrcPlaneU		,4
	param SrcPitchU		,4
	param SrcPlaneV		,4
	param SrcPitchV		,4
	param DstPlaneU		,4
	param DstPitchU		,4
	param DstPlaneV		,4
	param DstPitchV		,4
	param DstHeight		,4
	param DstWidth		,4
	param U_Table		,4
	
	var TempSrcPlane	,4
	var TempDstPlane	,4
	
	var TempDstPlaneU	,4
	var TempDstPlaneV	,4

	var TempSrcPlaneU	,4
	var TempSrcPlaneV	,4

	var TmpStore_U	,4
	var TmpStore_V	,4
	var NewVal_U	,4
	var NewVal_V	,4
endvars
	
	mov   edi, [U_Table]
	%define UTable edi
	%define VTable UTable+(256*256)
	

align 32
LoopUVHeight:
				mov         eax, [SrcPlaneU] 
				mov         [TempSrcPlaneU],eax 

				mov         eax,[SrcPlaneV] 
				mov         [TempSrcPlaneV],eax 				 

				mov         eax,[DstPlaneU] 
				mov         [TempDstPlaneU],eax 						 

				mov         eax,[DstPlaneV] 
				mov         [TempDstPlaneV],eax 

				mov			esi,[DstWidth]
				

align 64
LoopUVWidth:	
				%rep 4
				mov ebx, [TempSrcPlaneV]
				add [TempSrcPlaneV],dword 1
				movzx eax, byte[ebx]
							
				mov ebx, [TempSrcPlaneU]
				add [TempSrcPlaneU],dword 1
				mov ah, byte[ebx]		
					
				mov cl,[UTable+eax]
				ror ecx,8
				mov dl,[VTable+eax]
				ror edx,8
				%endrep   
 
				mov eax,[TempDstPlaneU]
				mov [eax],ecx
				add [TempDstPlaneU],dword 4

				mov ebx,[TempDstPlaneV]
				mov [ebx],edx
				add [TempDstPlaneV],dword 4

				sub esi,dword 4
				jg LoopUVWidth


				mov eax,[SrcPitchU]
				add [SrcPlaneU],eax

				mov eax,[SrcPitchV]	
				add [SrcPlaneV],eax

				mov eax,[DstPitchU]	
				add [DstPlaneU],eax

				mov eax,[DstPitchV]	
				add [DstPlaneV],eax

				sub [DstHeight],dword 1
				jg LoopUVHeight



endprocedure
;
; end of asm_x86_uvplane
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


