	%include "asm_macros.amc"

	segment	.text


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; asm_x86_YPlane
;
; in cpp use
;extern "C" void asm_x86_YPlane(  void*  SrcPlaneY,  uint32 SrcPitchY,
;								  void*  DstPlaneY,  uint32 DstPitchY,
;							      uint32 DstHeight,  uint32 DstWidth,
;								  const void* Y_Table);
;
procedure asm_x86_YPlane
	param SrcPlaneY		,4
	param SrcPitchY		,4
	param DstPlaneY		,4
	param DstPitchY		,4
	param DstHeight		,4
	param DstWidth		,4
	param Y_Table		,4
	
	var TempWidth		,4
	var TempSrcPlane	,4
	var TempDstPlane	,4
endvars
	
	;;;;;;;;;;;;;;;;;;;;;;;;
				

	 	mov	esi,[Y_Table]				;esi = y lookup table	;mov	ecx, [YUV_Table]
	 	%define YTable esi
	 	
.Loop_Yplane_Height:
		mov edx,[DstWidth]
		mov [TempWidth],edx

		mov edi,[SrcPlaneY]
		mov [TempSrcPlane],edi

		mov ecx,[DstPlaneY]
		mov [TempDstPlane],ecx

		;mov edi,[TempSrcPlane]			;edi = yplane current address
		%define TSrcPlane edi
		;mov ecx,[TempDstPlane]			;ecx = dest yplane
		%define TDstPlane ecx

align 64
.Loop_Yplane_Width:
		;%rep 4	to unroll but it wont fit in 1 cache line
			mov edx,[TSrcPlane]	;sourceplane bytes 1 to 4
			add TSrcPlane,4
					
			movzx eax,dl				;get byte 1 of yplane
			shr edx,8					;shr src values for byte 2 of yplane later
			movzx	ebx, byte [YTable+eax]	;get byte from lookup+offset eax (byte 1 of yplane), store in ebx			
			movzx eax,dl
			shr edx,8					;don't bother shifting on last byte, it's unneeded
			mov bh, byte [YTable+eax]
			ror ebx,16		
			movzx eax,dl
			shr edx,8					;don't bother shifting on last byte, it's unneeded
			mov bl, byte [YTable+eax]
			movzx eax,dl
			mov bh, byte [YTable+eax]
			ror ebx,16					

			mov	[TDstPlane], ebx
			add ecx,4
		;%endrep


		;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		;	next DstWidth block
		;
		sub dword  [TempWidth],4	;16 if unrolled
		jg .Loop_Yplane_Width
		
		;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		;	next DstHeight
		;		
		mov edx,[SrcPitchY]
		add [SrcPlaneY],edx
		mov edx,[DstPitchY]
		add [DstPlaneY],edx

		sub [DstHeight],dword 1
		jg .Loop_Yplane_Height
endprocedure
;
; end of asm_x86_yplane
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;



