/*	Quoted origional virtualdub licence
    This filter is intended for and used by virtualdub
   //	VirtualDub - Video processing and capture application
   //	Copyright (C) 1998-2001 Avery Lee
   //
   //	This program is free software; you can redistribute it and/or modify
   //	it under the terms of the GNU General Public License as published by
   //	the Free Software Foundation; either version 2 of the License, or
   //	(at your option) any later version.
   //
   //	This program is distributed in the hope that it will be useful,
   //	but WITHOUT ANY WARRANTY; without even the implied warranty of
   //	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   //	GNU General Public License for more details.
   //
   //	You should have received a copy of the GNU General Public License
   //	along with this program; if not, write to the Free Software
   //	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

//	Filter written by karl pritchett
//	Free for any use
//
//
//	Contains dead and test code due to it being a test piece
//	for the purpose of learning x86 and sse assembler
//	Next task is to clean it up and refactor it
//	(at the very least, to use consistant names for variables !!)
//
//	That said, use it if you want it
//

//#include "stdafx.h"


#include <vd2/VDXFrame/VideoFilter.h>
//#include <vd2/VDLib/Dialog.h>
//#include <vd2/plugin/vdvideoaccel.h>
#include <vd2/plugin/vdvideofilt.h>
//#include <vd2/system/cpuaccel.h>

#include <windows.h>
#include <commctrl.h>

#include <math.h>

#include "..\resource.h"

#include "f_dlone_extras.h"

extern HINSTANCE g_hInst;

struct T_UYVY
{ union
  { uint32 dw;
    struct
    { uint8 U;
      uint8 Y1;
      uint8 V;
      uint8 Y2;
    };
  };
};
typedef T_UYVY*P_UYVY;

struct T_YUYV
{ union
  { uint32 dw;
    struct
    { uint8 Y1;
      uint8 U;
      uint8 Y2;
			uint8 V;
    };
  };
};
typedef T_YUYV*P_YUYV;


//
///////////////////////////////////////////////////

static void brightcont_YUYV_sse( const VDXPixmap     &srcimage,
                                 const VDXPixmap     &dstimage,
                                 const YUV_TableDefs *YUV_Table,bool LeftHalfOnly )
{
  uint8    *SrcPlane = (uint8*)srcimage.data;
  uint8    *DstPlane = (uint8*)dstimage.data;
  ptrdiff_t SrcPitch = srcimage.pitch;
  ptrdiff_t DstPitch = dstimage.pitch;

	if ( (YUV_Table->AffectsUV || YUV_Table->AffectsY) && (dstimage.w>1) )
     { const void *TempForYTable = YUV_Table->Y_Table;
			 int w = dstimage.w;
			 if (LeftHalfOnly) 
				 w=w /2;
			 asm_sse_YUYV( SrcPlane,  SrcPitch, DstPlane,  DstPitch, dstimage.h, w, TempForYTable );
     }
} // brightcont_YUYV_sse


static void brightcont_YUYV_x86( const VDXPixmap     &srcimage,
                                 const VDXPixmap     &dstimage,
                                 const YUV_TableDefs *YUV_Table,bool LeftHalfOnly )
{
  uint8    *SrcPlane = (uint8*)srcimage.data;
  uint8    *DstPlane = (uint8*)dstimage.data;
  ptrdiff_t SrcPitch = srcimage.pitch;
  ptrdiff_t DstPitch = dstimage.pitch;

	if ( (YUV_Table->AffectsUV || YUV_Table->AffectsY) && (dstimage.w>1)  )
     {
			 const void *TempForYTable = YUV_Table->Y_Table;

			 if (LeftHalfOnly)
				 asm_x86_YUYV( SrcPlane,  SrcPitch,
											 DstPlane,  DstPitch,
											 dstimage.h, dstimage.w/2,
											 TempForYTable);
			 else
				 asm_x86_YUYV( SrcPlane,  SrcPitch,
											 DstPlane,  DstPitch,
											 dstimage.h, dstimage.w,
											 TempForYTable);
     }
} // brightcont_YUYV_x86


static void brightcont_UYVY_x86( const VDXPixmap     &srcimage,
                                 const VDXPixmap     &dstimage,
                                 const YUV_TableDefs *YUV_Table,bool LeftHalfOnly )
{
  uint8    *SrcPlane = (uint8*)srcimage.data;
  uint8    *DstPlane = (uint8*)dstimage.data;
  ptrdiff_t SrcPitch = srcimage.pitch;
  ptrdiff_t DstPitch = dstimage.pitch;

	if ( (YUV_Table->AffectsUV || YUV_Table->AffectsY)  && (dstimage.w>1)  )
     {
			 const void *TempForYTable = YUV_Table->Y_Table;

			 if (LeftHalfOnly)
				 asm_x86_UYVY( SrcPlane,  SrcPitch,
											 DstPlane,  DstPitch,
											 dstimage.h, dstimage.w/2,
											 TempForYTable );
			 else
				 asm_x86_UYVY( SrcPlane,  SrcPitch,
											 DstPlane,  DstPitch,
											 dstimage.h, dstimage.w,
											 TempForYTable );
     }
} // brightcont_UYVY_x86



static void brightcont_UYVY_sse( const VDXPixmap     &srcimage,
                                 const VDXPixmap     &dstimage,
                                 const YUV_TableDefs *YUV_Table,bool LeftHalfOnly )
{
  uint8    *SrcPlane = (uint8*)srcimage.data;
  uint8    *DstPlane = (uint8*)dstimage.data;
  ptrdiff_t SrcPitch = srcimage.pitch;
  ptrdiff_t DstPitch = dstimage.pitch;

	if ( (YUV_Table->AffectsUV || YUV_Table->AffectsY) && (dstimage.w>1)  )
     {
			 const void *TempForYTable = YUV_Table->Y_Table;

			 if (LeftHalfOnly)
				 asm_sse_UYVY( SrcPlane,  SrcPitch,
											 DstPlane,  DstPitch,
											 dstimage.h, dstimage.w/2,
											 TempForYTable );
			 else
				 asm_sse_UYVY( SrcPlane,  SrcPitch,
											 DstPlane,  DstPitch,
											 dstimage.h, dstimage.w,
											 TempForYTable );
     }
} 


static void brightcont_run_transYUV8_sse( const VDXPixmap     &srcimage,
                                          const VDXPixmap     &dstimage,
                                          int                  HDiv,
                                          int                  WDiv,
                                          const YUV_TableDefs *YUV_Table,bool LeftHalfOnly )
{
  void     *dstYplane     = dstimage.data;
  void     *srcYplane     = srcimage.data;

  void     *dstUplane     = dstimage.data2;
  void     *dstVplane     = dstimage.data3;
  void     *srcUplane     = srcimage.data2;
  void     *srcVplane     = srcimage.data3;

  uint32    width         = dstimage.w;
  uint32    YPlaneHeight  = dstimage.h;
  ptrdiff_t SrcPitchY     = srcimage.pitch;
  ptrdiff_t SrcPitchU     = srcimage.pitch2;
  ptrdiff_t SrcPitchV     = srcimage.pitch3;
  ptrdiff_t DstPitchY     = dstimage.pitch;
  ptrdiff_t DstPitchU     = dstimage.pitch2;
  ptrdiff_t DstPitchV     = dstimage.pitch3;

  int       UVPlaneHeight = YPlaneHeight;
  int       UVPlaneWidth  = width;

	if (width<2) 
		return;

  if ( HDiv > 0 ){ UVPlaneHeight = UVPlaneHeight / HDiv; }
  if ( WDiv > 0 ){ UVPlaneWidth = UVPlaneWidth / WDiv; }

	if (LeftHalfOnly)
		{ width = width/2;	UVPlaneWidth=UVPlaneWidth/2;	}

  if ( YUV_Table->AffectsY )
     asm_sse_YPlane( srcYplane, SrcPitchY, dstYplane, DstPitchY, YPlaneHeight, width, YUV_Table );
     
  if ( (SrcPitchU != 0) && (SrcPitchV != 0) && YUV_Table->AffectsUV )
    asm_sse_UVPlane( srcUplane,			SrcPitchU,		srcVplane,  SrcPitchV,
                     dstUplane,			DstPitchU,		dstVplane,  DstPitchV,
                     UVPlaneHeight, UVPlaneWidth, &YUV_Table->U_Table);
} // brightcont_run_transYUV8_sse


static void brightcont_run_transYUV8_x86( const VDXPixmap     &srcimage,
                                          const VDXPixmap     &dstimage,
                                          int                  HDiv,
                                          int                  WDiv,
                                          const YUV_TableDefs *YUV_Table,bool LeftHalfOnly )
{
  uint32    DstWidth         = dstimage.w;
  uint32    DstHeight        = dstimage.h;

  void     *SrcPlaneY        = srcimage.data;
  void     *DstPlaneY        = dstimage.data;
  ptrdiff_t SrcPitchY        = srcimage.pitch;
  ptrdiff_t DstPitchY        = dstimage.pitch;

  void     *DstPlaneU        = dstimage.data2;
  void     *DstPlaneV        = dstimage.data3;
  void     *SrcPlaneU        = srcimage.data2;
  void     *SrcPlaneV        = srcimage.data3;
  ptrdiff_t SrcPitchU        = srcimage.pitch2;
  ptrdiff_t SrcPitchV        = srcimage.pitch3;
  ptrdiff_t DstPitchU        = dstimage.pitch2;
  ptrdiff_t DstPitchV        = dstimage.pitch3;

  int       DstUVPlaneHeight = DstHeight;
  int       DstUVPlaneWidth  = DstWidth;

	if (dstimage.w<2) 
		return;

  if ( HDiv > 0 ) { DstUVPlaneHeight = DstUVPlaneHeight / HDiv; }

  if ( WDiv > 0 ) { DstUVPlaneWidth = DstUVPlaneWidth / WDiv; }

	if (LeftHalfOnly)
		{ DstWidth=DstWidth/2;
			DstUVPlaneWidth=DstUVPlaneWidth/2;
		};

  if ( YUV_Table->AffectsY )
     {
     const void *TempForYTable = YUV_Table;
     asm_x86_YPlane( SrcPlaneY, SrcPitchY, DstPlaneY, DstPitchY, DstHeight, DstWidth, TempForYTable );
     }

  if ( (SrcPitchU != 0) && (SrcPitchV != 0) && YUV_Table->AffectsUV )
		asm_x86_UVPlane( SrcPlaneU,		SrcPitchU,		SrcPlaneV,   SrcPitchV,
										 DstPlaneU,   DstPitchU,		DstPlaneV,   DstPitchV,
										 DstUVPlaneHeight,   DstUVPlaneWidth, &YUV_Table->U_Table );
     
} // brightcont_run_transYUV8_x86


///////////////////////////////////////////////////////////////////////////////////////

void brightcont_run_transYUVPlanar( const VDXPixmap &srcimage,	const VDXPixmap &dstimage,
                                    int HDiv, int WDiv, const YUV_TableDefs *YUV_Table,
                                    int MyCpuType, bool LeftHalfOnly )
{
	switch ( MyCpuType )
				 {
				 case 0:	brightcont_run_transYUV8_sse( srcimage, dstimage, HDiv, WDiv, YUV_Table, LeftHalfOnly ); break;										 
				 case 1:	brightcont_run_transYUV8_x86( srcimage, dstimage, HDiv, WDiv, YUV_Table, LeftHalfOnly ); break;																												
				 default:	brightcont_run_transYUV8_x86( srcimage, dstimage, HDiv, WDiv, YUV_Table, LeftHalfOnly );																							
				 }
}  //end brightcont_run_transYUV8


void brightcont_run_transYUYVInline( const VDXPixmap &srcimage,	const VDXPixmap &dstimage,
                                     const YUV_TableDefs *YUV_Table, int MyCpuType, bool LeftHalfOnly )
{
  switch ( MyCpuType )
         {
				 case 0:	brightcont_YUYV_sse( srcimage, dstimage, YUV_Table, LeftHalfOnly );	break;					
				 case 1:	brightcont_YUYV_x86( srcimage, dstimage, YUV_Table, LeftHalfOnly ); break;			          
				 default: brightcont_YUYV_x86( srcimage, dstimage, YUV_Table, LeftHalfOnly );
         }
} // brightcont_run_transYUYVInline


extern void brightcont_run_transUYVYInline( const VDXPixmap &srcimage, const VDXPixmap &dstimage,
                                            const YUV_TableDefs *YUV_Table, int MyCpuType, bool LeftHalfOnly )
{
  switch ( MyCpuType )
         {
				 case 0:	brightcont_UYVY_sse( srcimage, dstimage, YUV_Table, LeftHalfOnly ); break;
				 case 1:	brightcont_UYVY_x86( srcimage, dstimage, YUV_Table, LeftHalfOnly ); break;
				 default:	brightcont_UYVY_x86( srcimage, dstimage, YUV_Table, LeftHalfOnly );
         }
}